<?php
class QuickPost extends plxPlugin {
	public function __construct($default_lang) {
		parent::__construct($default_lang);
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->addHook('IndexBegin','IndexBegin');
		$this->addHook('AdminProfilTop','AdminProfilTop');
		$this->addHook('AdminArticleTop','AdminArticleTop');
		$this->addHook('AdminArticlePrepend','AdminArticlePrepend');

		
	}

	public function OnActivate() {
	
	}
	public function OnDeactivate() {
		
	}

	public function echo_bookmarklet(){
		global $plxAdmin;
		echo '<br/><a href="javascript:javascript:(function(){var url = location.href;var title = document.title || url;window.open(\''.$plxAdmin->racine.'?url=\' + encodeURIComponent(url)+\'&user='.$_SESSION['user'].'\'+\'&title=\' + encodeURIComponent(title)+\'&source=bookmarklet\',\'mybookmarklet\',\'menubar=no,height=600,width=800,toolbar=no,scrollbars=no,status=no\');})();" title="glisser-dposer ce lien sur votre barre de favoris">Lien pour poster sur '.$plxAdmin->aConf['title'].'</a>';
	}
	public function title2url($str){
		$str = htmlentities($str, ENT_NOQUOTES, $charset);
	    $str = preg_replace('#\&([A-za-z])(?:acute|cedil|circ|grave|ring|tilde|uml|uro)\;#', '\1', $str);
	    $str = preg_replace('#\&([A-za-z]{2})(?:lig)\;#', '\1', $str); 
	    $str = preg_replace('#\&[^;]+\;#', '', $str); 
	    $str = preg_replace('/[^[:alnum:]]+/',' ',$str);
		return strtolower(strtr(trim($str), ' ', '-'));

	}
	public function get_tag_list(){ // pas encore utilis: 
		global $plxMotor;$tags=array();
		foreach($plxMotor->aTags as $article){
			$tag=array_flip(array_map('trim',explode(',',$article['tags'])));
			$tags=array_merge($tags,$tag);
		}
		$taglist='';
		foreach($tags as $tag=>$osef){if (!empty($tag)){$taglist.='<option value="'.$tag.'">';}}
 		return $taglist;
	}

	# HOOKS
	public function IndexBegin(){
		global $plxMotor,$plxPlugins;
		//gestion de la gnration du formulaire si on vient du bookmarklet
		if (!empty($_GET['source'])&&$_GET['source']=='bookmarklet'){
			
			echo '<html><head><title>Post rapide sur le site</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
			echo '<style>'.file_get_contents(PLX_PLUGINS.'QuickPost/style.css').'</style></head><body>';
			echo '
				<h1> Post rapide sur '.$plxMotor->aConf['title'].' </h1>
				<form action="'.$plxMotor->racine.'index.php" method="post">
					<input type="hidden" name="source" value="bookmarklet"/>
					<input type="hidden" name="login" value="'. $plxMotor->aUsers[strip_tags($_GET['user'])]['login'].'"/>
					<input type="hidden" name="author" value="'.$_GET['user'].'"/>
					<input type="hidden" name="day" value="'.date('d').'"/>
					<input type="hidden" name="month" value="'.date('m').'"/>
					<input type="hidden" name="year" value="'.date('Y').'"/>
					<input type="hidden" name="time" value="'.date('H:i').'"/>
					<input type="hidden" name="new_catname" value=""/>
					<input type="hidden" name="title_htmltag" value=""/>
					<input type="hidden" name="meta_description" value=""/>
					<input type="hidden" name="meta_keywords" value="home"/>
					<input type="hidden" name="artId" value=""/>
					
					<input type="hidden" name="allow_com" value="1"/>
					<input type="hidden" name="url" value="'.strip_tags($_GET['title']).'"/>
					<input type="hidden" name="template" value="article.php"/>';
					if (empty($_SESSION['user'])){echo '<label>Mot de passe</label><input type="password" name="password"/>';}

					echo '<label>Titre du post/de la page d\'origine</label>
					<input type="text" name="title" value="'.strip_tags($_GET['title']).'"/>
					<label>Tags</label>
					<input type="text" name="tags" value="" list="tags_list"/>
					<datalist id="cars">'.$this->get_tag_list().'</datalist>
					<label>Categories</label><ul>
							<li><input type="checkbox" id="home" name="catId[]" value="home">
							<label for="home">&nbsp;Page d\'accueil</label></li>
					';
					foreach($plxMotor->aCats as $id=>$cat){
						echo '
							<li><input type="checkbox" id="cat_'.$id.'" name="catId[]" value="'.$id.'">
							<label for="cat_'.$id.'">&nbsp;'.$cat['name'].'</label></li>
						';
					}
					$a=strip_tags($_GET['url']);
					echo '</ul><label>Contenu du post</label>
					<textarea name="content"><a href="'.$a.'">'.$a.'</a></textarea>
					<input type="submit" name="publish" value="Publier"/>';
					

				echo '</form>
				</body></html>
			';
			exit();
		}


		# Authentification si necessaire
		if(!empty($_POST['login']) AND !empty($_POST['password']) AND !empty($_POST['source']) ) {
			$connected = false;
			foreach($plxMotor->aUsers as $userid => $user) {
				if ($_POST['login']==$user['login'] AND sha1($user['salt'].md5($_POST['password']))==$user['password'] AND $user['active'] AND !$user['delete']) {
					$_SESSION['user'] = $userid;
					$_SESSION['profil'] = $user['profil'];
					$_SESSION['hash'] = plxUtils::charAleatoire(10);
					$_SESSION['domain'] = $session_domain;
					$_SESSION['lang'] = $user['lang'];
					$connected = true;
				}

			}
			if(!$connected || empty($_SESSION['user']) || empty($_SESSION['hash'])) { 
				var_dump(empty($_SESSION['domain']));
				exit ('Erreur d\'identification');
			}

		}



		if (!empty($_POST['source'])&&$_POST['source']=='bookmarklet'){
			$_SESSION['postdata']=$_POST;
			$_SESSION['postdata']['url']=$this->title2url($_SESSION['postdata']['url']).uniqid();
			$_SESSION['postdata']['content']=nl2br($_SESSION['postdata']['content']);
			header('location: '.PLX_CORE.'admin/article.php');
			exit;
		}

	}


	public function AdminArticlePrepend(){
		

		# Recuperation des donnees $_POST depuis la session
		if (isset($_SESSION['postdata'])){$_POST=$_SESSION['postdata'];unset($_SESSION['postdata']);$_SESSION['close_bookmarklet']=true;}

	}

	public function AdminProfilTop(){
		$this->echo_bookmarklet();	
	}
	public function AdminArticleTop(){
		// fermeture du bookmarklet en verifiant la variable de session transmise (pour eviter de parasiter l'edition normale d'un article)
		if (!empty($_SESSION['close_bookmarklet'])){unset($_SESSION['close_bookmarklet']);exit('<script>window.close();</script>');}
	}

	

}

?>
